VERSION 5.00
Begin VB.Form frmDDEServer 
   Caption         =   "DDEML Server"
   ClientHeight    =   2970
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   4350
   LinkTopic       =   "Form1"
   ScaleHeight     =   2970
   ScaleWidth      =   4350
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fPokeData 
      Caption         =   "Poke Data"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1335
      Left            =   120
      TabIndex        =   1
      Top             =   1440
      Width           =   4095
      Begin VB.TextBox txtPokeData 
         Height          =   975
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   2
         Top             =   240
         Width           =   3855
      End
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This is the DDE server window."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   4095
   End
End
Attribute VB_Name = "frmDDEServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*************************************************************************
'
' Copyright (c) 2001
'
' Author:   Eric D. Wilson
' Email:    edwilson97@yahoo.com
'
' NOTE:
' This application demonstrates how to program a DDE server through the
' DDE Management Library. This is an alternative to the standard form based
' DDE mechanism that is provided with Visual Basic.

' There is very little documentation on using the DDEML through Visual Basic
' so it takes a little trial and error. A perfect example is the function
' declaration for DdeGetData(). The decalration that you get from the API loader
' is incorrect. You have to remove the Alias otherwise it won't work. There
' are some other changes that I had to make like variable types. I've tried
' to add a comment for all the ones I've changed.
'
' This app provides an example DDE server. The server is very basic. It provides
' processing for the major DDE transaction types Execute, Poke, and Request.
'
' ** When you start the server it will be minimized to the task bar.
'
' Here are some tests you can run.
'
' ************************************************************************
'
' Execute:
'
' With the server running setup the following information in a DDE client.
'
'   Service:    DDEServer   - This is the server name.
'   Topic:      DDETopic    - This is the only defined topic.
'   Value:      This can be one of three commands specified in the server.
'               Acceptable values are:
'
'               MAX     - This will maximize the window.
'               MIN     - This will minimize the window.
'               NORMAL  - This will give the in between setting.
'
' Once you set up these values you can initiate an Execute transaction. The
' server window state should then be adjusted to match the command.
'
' ************************************************************************
'
' Poke:
'
' With the server running setup the following information in a DDE client.
'
'   Service:    DDEServer
'   Topic:      DDETopic
'   Item:       POKE        - This is the item value I created for Poke operations.
'   Value:      This is a test.     (This can be any string you want)
'
' Now if you initiate a poke operation from your DDE client you should see the
' DDE server window appear (if it was minimized) and the string value that you
' specified should now show up in the "Poke Data" text box.
'
'*************************************************************************
'
' Request:
'
' With the server running setup the following information in a DDE client.
'
'   Service:    DDEServer
'   Topic:      DDETopic
'   Item:       PLEASE        - This is the item value I created for Request
'                               operations. You should always ask nicely! :-)
'
' If your not using the DDEML client you need to make sure you have a mechanism
' set up in your client to print the return value of the request operation.
'
' If you initiate the request operation you should receive the following
' string from the server:
'
'   "This is a test of the emergency broadcast system."
'
'*************************************************************************
'
' While these are faily basic tests there are more advanced functionality
' that you can add to the server like client notification when server data
' changes. For further information check the MSDN documentation for information
' on the various transaction types XTYP_??.
'
'*************************************************************************

Option Explicit

' This is just a string that we'll return whenever a client performs a DDE
' request.
Private Const DDE_REQUEST_STRING = "This is a test of the emergency broadcast system."

Private lInstID As Long             ' DDE instance identifier.
Private hszDDEServer As Long        ' String handle for the server name.
Private hszDDETopic As Long         ' String handle for the topic name.
Private hDDEConv As Long            ' Handle to the DDE conversation.
Private lDDERet As Long             ' Generic return variable.
Private bRunning As Boolean         ' Server running flag.

Private Sub Form_Load()
    
    ' Initialize the DDE subsystem. We need to let the DDEML know what callback
    ' function we intend to use so we pass it address using the AddressOf operator.
    ' If we can't initialize the DDEML subsystem we exit.
    If DdeInitialize(lInstID, AddressOf DDECallback, 0, 0) Then
        Exit Sub
    End If
   
    ' Now that the DDEML subsystem is initialized we create string handles for our
    ' server/topic name.
    hszDDEServer = DdeCreateStringHandle(lInstID, DDE_SERVER, CP_WINANSI)
    hszDDETopic = DdeCreateStringHandle(lInstID, DDE_TOPIC, CP_WINANSI)
    
    ' Lets check to see if another DDE server has already registered with identical
    ' server/topic names. If so we'll exit. If we were to continue the DDE subsystem
    ' could become unstable when a client tried to converse with the server/topic.
    If (DdeConnect(lInstID, hszDDEServer, hszDDETopic, ByVal 0&)) Then
        MsgBox "A DDE server named " & Chr(34) & DDE_SERVER & Chr(34) & " with topic " & _
                Chr(34) & DDE_TOPIC & Chr(34) & " is already running.", vbExclamation, App.Title
        Unload Me
        Exit Sub
    End If
        
    ' We need to register the server with the DDE subsystem.
    If (DdeNameService(lInstID, hszDDEServer, 0, DNS_REGISTER)) Then
        ' Set the server running flag.
        bRunning = True
    End If
    
    Me.WindowState = vbMinimized
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    ' We need to release our string handles.
    DdeFreeStringHandle lInstID, hszDDEServer
    DdeFreeStringHandle lInstID, hszDDETopic
    
    ' Unregister the DDE server.
    If bRunning Then
        DdeNameService lInstID, hszDDEServer, 0, DNS_UNREGISTER
    End If
    
    ' Break down the link with the DDE subsystem.
    DdeUninitialize lInstID
End Sub

Function HandleDDECallback(ByVal wType As Long, _
                            ByVal wFmt As Long, _
                            ByVal hConv As Long, _
                            ByVal hszTopic As Long, _
                            ByVal hszItem As Long, _
                            ByVal hData As Long, _
                            ByVal lData1 As Long, _
                            ByVal lData2 As Long) As Long
    
    Dim iCount As Long
    Dim Buffers As String
    Dim Ret As Long
    
    Select Case wType
        ' Process the connect transaction.
        Case XTYP_CONNECT
            ' Just return a positive acknowledgement. If we don't the conversation will
            ' never be completed between us and the client.
            Ret = DDE_FACK
            
        ' Process the request transaction.
        Case XTYP_REQUEST
            ' What's the size of the string?
            iCount = DdeQueryString(lInstID, hszItem, vbNullString, 0, CP_WINANSI)
            
            ' Allocate space for the string.
            Buffers = Space(iCount)
            
            ' Grab the string.
            DdeQueryString lInstID, hszItem, Buffers, iCount + 1, CP_WINANSI
            
            ' This just ensures that we understand the string regardless of case.
            Buffers = UCase(Buffers)
            
            ' Check to see if the client is requesting something we can supply.
            If (Buffers = DDE_REQUEST) Then
                ' Create a data object and populate it with our string. Then return the object.
                Ret = DdeCreateDataHandle(lInstID, DDE_REQUEST_STRING, Len(DDE_REQUEST_STRING) + 4, 0, hszItem, CF_TEXT, 0)
            Else
                ' The client didn't ask nicely so we're not going to process the request.
                Ret = DDE_FNOTPROCESSED
            End If
            
        ' Process the execute transaction.
        Case XTYP_EXECUTE
            ' What's the size of the string?
            iCount = DdeGetData(ByVal hData, vbNullString, 0, 0)
            
            ' Allocate space for the buffer.
            Buffers = Space(iCount)
            
            ' Grab the DDE data object.
            DdeGetData ByVal hData, Buffers, iCount, 0
            
            Buffers = UCase(Buffers)
            
            ' Set the default return.
            Ret = DDE_FACK
            
            ' Did the client specify a command that we understand?
            If (Buffers = DDE_COMMAND1) Then
                Me.WindowState = vbMaximized
            ElseIf (Buffers = DDE_COMMAND2) Then
                Me.WindowState = vbMinimized
            ElseIf (Buffers = DDE_COMMAND3) Then
                Me.WindowState = vbNormal
            Else
                Ret = DDE_FNOTPROCESSED
            End If
            
        ' Process the poke request.
        Case XTYP_POKE
            iCount = DdeQueryString(lInstID, hszItem, vbNullString, 0, CP_WINANSI)
            Buffers = Space(iCount)
            DdeQueryString lInstID, hszItem, Buffers, iCount + 1, CP_WINANSI

            Buffers = UCase(Buffers)

            If (Buffers = DDE_POKE) Then
                ' Since the client is sending data for an item that we support we can
                ' grab the data.
                iCount = DdeGetData(ByVal hData, vbNullString, 0, 0)
            
                ' Allocate space for the buffer.
                Buffers = Space(iCount)
            
                ' Grab the DDE data object.
                DdeGetData ByVal hData, Buffers, iCount, 0
                            
                ' Make sure the window is visible.
                Me.WindowState = vbNormal
                
                ' Add the data to the text box.
                txtPokeData.Text = Buffers
                
                Ret = DDE_FACK
            Else
                Ret = DDE_FNOTPROCESSED
            End If
                                    
    End Select
    
    ' Set the final callback return.
    HandleDDECallback = Ret
    
End Function


